﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Datos.AccesoDatos
{
    //Esta clase utiliza el patrón Singleton. De esta forma garantizamos una única instancia de la clase de acceso a datos.
    public class Departamentos
    {
        private static Departamentos _departamentos;
        private GGPEntities _container;

        private Departamentos()
        {
            _container = new GGPEntities();
        }

        public static Departamentos Instanciar()
        {
            if (_departamentos == null)
                _departamentos = new Departamentos();
            
            return _departamentos;
        }

        public IEnumerable<Departamento> ObtenerDepartamentos()
        {
            return _container.Departamento.AsEnumerable();
        }

        public void CrearDepartamento(string nombre, bool activo, int porcentajePlusFestivo)
        {
            var departamento = new Departamento() { nombre = nombre, activo = activo, porcentajePlusFestivo = porcentajePlusFestivo };
            _container.Departamento.Add(departamento);
            _container.SaveChanges();
        }

        public void ModificarDepartamento(int idDepartamento, string nombre, bool activo, int porcentajePlusFestivo)
        {
            var departamento = ObtenerDepartamento(idDepartamento);

            if (departamento != null)
            {
                departamento.nombre = nombre;
                departamento.activo = activo;
                departamento.porcentajePlusFestivo = porcentajePlusFestivo;
                _container.SaveChanges();
            }
        }

        public Departamento ObtenerDepartamento(int idDepartamento)
        {
            return _container.Departamento.Where(x => x.idDepartamento == idDepartamento).FirstOrDefault();
        }

        public Departamento ObtenerDepartamento(string nombre)
        {
            return _container.Departamento.Where(x => x.nombre == nombre).FirstOrDefault();
        }

    }
}
