﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Datos.AccesoDatos
{
    //Esta clase utiliza el patrón Singleton. De esta forma garantizamos una única instancia de la clase de acceso a datos.
    public class DetallesHojaGastos
    {
        private static DetallesHojaGastos _detallesHojaGastos;
        private GGPEntities _container;

        private DetallesHojaGastos()
        {
            _container = new GGPEntities();
        }

        public static DetallesHojaGastos Instanciar()
        {
            if (_detallesHojaGastos == null)
                _detallesHojaGastos = new DetallesHojaGastos();

            return _detallesHojaGastos;
        }

        public IEnumerable<DetalleHojaGastos> ObtenerDetallesHojaGastos(int idHojaGastos)
        {
            return _container.DetalleHojaGastos.Where(x => x.idHojaGastos == idHojaGastos).AsEnumerable();
        }

        public void CrearDetalleHojaGastos(int idHojaGastos, int idTipoGasto, string descripcion, string observaciones,
            DateTime fechaInicio, DateTime fechaFin, double importe, double importeCalculado, byte[] imagenAdjunta)
        {
            var detalleHojaGastos = new DetalleHojaGastos()
            {
                idHojaGastos = idHojaGastos,
                idTipoGasto = idTipoGasto,
                descripcion = descripcion,
                observaciones = observaciones,
                fechaInicio = fechaInicio,
                fechaFin = fechaFin,
                importe = importe,
                importeCalculado = importeCalculado,
                imagenAdjunta = imagenAdjunta
            };
            _container.DetalleHojaGastos.Add(detalleHojaGastos);
            _container.SaveChanges();
        }

        public DetalleHojaGastos ObtenerDetalleHojaGastos(int idDetalleHojaGastos)
        {
            return _container.DetalleHojaGastos.Where(x => x.idDetalleHojaGastos == idDetalleHojaGastos).FirstOrDefault();
        }
    }
}
