﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Datos.AccesoDatos
{
    //Esta clase utiliza el patrón Singleton. De esta forma garantizamos una única instancia de la clase de acceso a datos.
    public class Usuarios
    {
        private static Usuarios _usuarios;
        private GGPEntities _container;

        private Usuarios()
        {
            _container = new GGPEntities();
        }

        public static Usuarios Instanciar()
        {
            if (_usuarios == null)
                _usuarios = new Usuarios();

            return _usuarios;
        }


        public IEnumerable<Usuario> ObtenerUsuarios()
        {
            return _container.Usuario.AsEnumerable();
        }

        public IEnumerable<Usuario> ObtenerUsuarios(int idDepartamento)
        {
            return _container.Usuario.Where(x => x.idDepartamento == idDepartamento).AsEnumerable();
        }

        public void CrearUsuario(string nombre, string apellidos, string nombreLogin, string contrasena,
            bool activo, int idDepartamento, int rol)
        {
            var usuario = new Usuario() { nombre = nombre, apellidos = apellidos, nombreLogin = nombreLogin, contrasena = contrasena, activo = activo, idDepartamento = idDepartamento, rol = rol };
            _container.Usuario.Add(usuario);
            _container.SaveChanges();
        }

        public void ModificarUsuario(int idUsuario, string nombre, string apellidos, string nombreLogin, string contrasena,
            bool activo, int idDepartamento, int rol)
        {
            var usuario = ObtenerUsuario(idUsuario);

            if (usuario != null)
            {
                usuario.nombre = nombre;
                usuario.apellidos = apellidos;
                usuario.nombreLogin = nombreLogin;
                usuario.contrasena = contrasena;
                usuario.activo = activo;
                usuario.idDepartamento = idDepartamento;
                usuario.rol = rol;
                _container.SaveChanges();
            }
        }

        public Usuario ObtenerUsuario(int idUsuario)
        {
            return _container.Usuario.Where(x => x.idUsuario == idUsuario).FirstOrDefault();       
        }

        public Usuario ObtenerUsuario(String nombreLogin)
        {
            return _container.Usuario.Where(x => x.nombreLogin == nombreLogin).FirstOrDefault();
        }
    }
}
