﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GGP.Administracion.Departamentos
{
    public partial class frmGestionDepartamentos : Form
    {
        private Estados _estado;

        public frmGestionDepartamentos()
        {
            InitializeComponent();

            var session = Negocio.FachadaNegocio.SesionUsuario.Instanciar();

            switch (session.Rol)
	        {
		        case Negocio.Modulos.TipoRolUsuario.Administrador:
                    _estado = Estados.NavegacionAdministrador;
                    break;
                case Negocio.Modulos.TipoRolUsuario.Empleado:
                     MessageBox.Show("No tiene permisos para acceder a este mantenimiento.", "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    this.Close();  
                    break;
                case Negocio.Modulos.TipoRolUsuario.Responsable:
                     MessageBox.Show("No tiene permisos para acceder a este mantenimiento.", "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    this.Close();  
                    break;
                default:
                    break;
	        }
            
            RealizarAccion(Acciones.CargarFormulario);
        }

        private enum Estados
        {
            NavegacionAdministrador,
        }

        private enum Acciones
        {
            CargarFormulario,
            ListarDepartamentos,
            NuevoDepartamento,
            Atras,
            Ayuda
        }
        
        private void RealizarAccion(Acciones accion)
        {
            try
            {
                switch (_estado)
                {
                    case Estados.NavegacionAdministrador:
                        switch (accion)
                        {
                            case Acciones.CargarFormulario:
                                break;
                            case Acciones.ListarDepartamentos:
                                RealizarListarDepartamentos();
                                break;
                            case Acciones.NuevoDepartamento:
                                RealizarNuevoDepartamento();
                                break;
                            case Acciones.Atras:
                                RealizarAtras();
                                break;
                            case Acciones.Ayuda:
                                RealizarAyuda();
                                break;
                            default:
                                break;
                        }
                        break;

                    default:
                        break;
                }

                HabilitarControles();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void HabilitarControles()
        {
            switch (_estado)
            {
                case Estados.NavegacionAdministrador:
                    btnDepartamentos.Visible = true;
                    btnNuevoDepartamento.Visible = true;
                    btnAtras.Visible = true;
                    break;

                default:
                    break;
            }
        }

        private void RealizarListarDepartamentos()
        {
            var frmListarDepartamentos = new ListarDepartamentos();
            frmListarDepartamentos.ShowDialog();
        }
         
        private void RealizarNuevoDepartamento()
        {
            var frmDetalleDepartamento = new frmDetalleDepartamento(null);
            frmDetalleDepartamento.ShowDialog();
        }

        private void RealizarAtras()
        {
            this.Close();
        }

        private void RealizarAyuda()
        {
            var ayuda = new StringBuilder();
            ayuda.Append("Seleccione la opción que desea realizar.");
            ayuda.Append(" La opción 'Departamentos' le permite ver la lista de departamentos creados y editar estos departamentos.");
            ayuda.Append(" La opción 'Nuevo departamento' le permite crear un nuevo departamento.");
            ayuda.Append(" Si desea volver atrás, puede seleccionar la opción Atrás'.");
            MessageBox.Show(ayuda.ToString(), "Ayuda", MessageBoxButtons.OK, MessageBoxIcon.Question);
        }

        private void btnDepartamentos_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.ListarDepartamentos);
        }

        private void btnNuevoDepartamento_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.NuevoDepartamento);
        }

        private void btnAtras_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.Atras);
        }

        private void btnAyuda_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.Ayuda);
        }

    }
}
