﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GGP.Administracion.TiposGastos
{
    public partial class GestionTiposGastos : Form
    {
        private Estados _estado;

        public GestionTiposGastos()
        {
            InitializeComponent();

            var session = Negocio.FachadaNegocio.SesionUsuario.Instanciar();

             switch (session.Rol)
	        {
		        case Negocio.Modulos.TipoRolUsuario.Administrador:
                    _estado = Estados.NavegacionAdministrador;
                    break;
                case Negocio.Modulos.TipoRolUsuario.Empleado:
                     MessageBox.Show("No tiene permisos para acceder a este mantenimiento.", "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    this.Close();  
                    break;
                case Negocio.Modulos.TipoRolUsuario.Responsable:
                     MessageBox.Show("No tiene permisos para acceder a este mantenimiento.", "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    this.Close();  
                    break;
                default:
                    break;
	        }
            
            RealizarAccion(Acciones.CargarFormulario);   
        }

        private enum Estados
        {
            NavegacionAdministrador,
        }

        private enum Acciones
        {
            CargarFormulario,
            ListarTiposGasto,
            NuevoTipoGasto,
            Atras,
            Ayuda
        }
        
        private void RealizarAccion(Acciones accion)
        {
            try
            {
                switch (_estado)
                {
                    case Estados.NavegacionAdministrador:
                        switch (accion)
                        {
                            case Acciones.CargarFormulario:
                                break;
                            case Acciones.ListarTiposGasto:
                                RealizarListarTiposGasto();
                                break;
                            case Acciones.NuevoTipoGasto:
                                RealizarNuevoTipoGasto();
                                break;
                            case Acciones.Atras:
                                RealizarAtras();
                                break;
                            case Acciones.Ayuda:
                                RealizarAyuda();
                                break;
                            default:
                                break;
                        }
                        break;

                    default:
                        break;
                }

                HabilitarControles();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void HabilitarControles()
        {
            switch (_estado)
            {
                case Estados.NavegacionAdministrador:
                    btnTiposGastos.Visible = true;
                    btnNuevoTipoGasto.Visible = true;
                    btnAtras.Visible = true;
                    break;

                default:
                    break;
            }
        }

        private void RealizarListarTiposGasto()
        {
            var frmListaTiposGastos = new ListaTiposGastos();
            frmListaTiposGastos.ShowDialog();
        }

        private void RealizarNuevoTipoGasto()
        {
            var frmDetalleTipoGasto = new DetalleTipoGasto(null);
            frmDetalleTipoGasto.ShowDialog();
        }

        private void RealizarAtras()
        {
            this.Close();
        }

        private void RealizarAyuda()
        {
            var ayuda = new StringBuilder();
            ayuda.Append("Seleccione la opción que desea realizar.");
            ayuda.Append(" La opción 'Tipos de gastos' le permite ver la lista de tipos de gastos creados y editar estos tipos de gastos.");
            ayuda.Append(" La opción 'Nuevo tipo de gasto' le permite crear un nuevo tipo de gasto.");
            ayuda.Append(" Si desea volver atrás, puede seleccionar la opción Atrás'.");
            MessageBox.Show(ayuda.ToString(), "Ayuda", MessageBoxButtons.OK, MessageBoxIcon.Question);
        }

        private void btnTiposGastos_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.ListarTiposGasto);
        }

        private void btnNuevoTipoGasto_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.NuevoTipoGasto);
        }

        private void btnAtras_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.Atras);
        }

        private void btnAyuda_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.Ayuda);
        }


    }
}
