﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GGP.Administracion.EmpleadosRoles
{
    public partial class GestionEmpleadosRoles : Form
    {
        private Estados _estado;

        public GestionEmpleadosRoles()
        {
            InitializeComponent();

            var session = Negocio.FachadaNegocio.SesionUsuario.Instanciar();

            switch (session.Rol)
	        {
		        case Negocio.Modulos.TipoRolUsuario.Administrador:
                    _estado = Estados.NavegacionAdministrador;
                    break;
                case Negocio.Modulos.TipoRolUsuario.Empleado:
                     MessageBox.Show("No tiene permisos para acceder a este mantenimiento.", "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    this.Close();  
                    break;
                case Negocio.Modulos.TipoRolUsuario.Responsable:
                     MessageBox.Show("No tiene permisos para acceder a este mantenimiento.", "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    this.Close();  
                    break;
                default:
                    break;
        	}
        
            RealizarAccion(Acciones.CargarFormulario);   
        }

        private enum Estados
        {
            NavegacionAdministrador,
        }

        private enum Acciones
        {
            CargarFormulario,
            ListarUsuarios,
            NuevoUsuario,
            Atras,
            Ayuda
        }
        
        private void RealizarAccion(Acciones accion)
        {
            try
            {
                switch (_estado)
                {
                    case Estados.NavegacionAdministrador:
                        switch (accion)
                        {
                            case Acciones.CargarFormulario:
                                break;
                            case Acciones.ListarUsuarios:
                                RealizarListarUsuarios();
                                break;
                            case Acciones.NuevoUsuario:
                                RealizarNuevoUsuario();
                                break;
                            case Acciones.Atras:
                                RealizarAtras();
                                break;
                            case Acciones.Ayuda:
                                RealizarAyuda();
                                break;
                            default:
                                break;
                        }
                        break;

                    default:
                        break;
                }

                HabilitarControles();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void HabilitarControles()
        {
            switch (_estado)
            {
                case Estados.NavegacionAdministrador:
                    btnListaUsuarios.Visible = true;
                    btnNuevoUsuario.Visible = true;
                    btnAtras.Visible = true;
                    break;

                default:
                    break;
            }
        }

        private void RealizarListarUsuarios()
        {
            var frmListaUsuarios = new frmListaUsuarios();
            frmListaUsuarios.ShowDialog();
        }

        private void RealizarNuevoUsuario()
        {
            var frmDetalleUsuario = new GGP.Administracion.UsuariosRoles.DetalleUsuario(null);
            frmDetalleUsuario.ShowDialog();

        }

        private void RealizarAtras()
        {
            this.Close();
        }

        private void RealizarAyuda()
        {
            var ayuda = new StringBuilder();
            ayuda.Append("Seleccione la opción que desea realizar.");
            ayuda.Append(" La opción 'Lista de usuarios' le permite ver la lista de usuarios creados y editar estos usuarios.");
            ayuda.Append(" La opción 'Nuevo usuario' le permite crear un nuevo usuario.");
            ayuda.Append(" Si desea volver atrás, puede seleccionar la opción Atrás'.");
            MessageBox.Show(ayuda.ToString(), "Ayuda", MessageBoxButtons.OK, MessageBoxIcon.Question);
        }

        private void btnListaUsuarios_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.ListarUsuarios);
        }

        private void btnNuevoUsuario_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.NuevoUsuario);
        }

        private void btnAtras_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.Atras);
        }

        private void btnAyuda_Click(object sender, EventArgs e)
        {
            RealizarAccion(Acciones.Ayuda);
        }
    }
}
