﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GGP
{
    public partial class Login : Form
    {
        public bool LoginCorrecto { get; set; }
        
        public Login()
        {
            InitializeComponent();

            this.txtContrasena.KeyDown += this.txtContrasena_keyDown;
        }

        private void btnEntrar_Click(object sender, EventArgs e)
        {
            try
            {
                LoginCorrecto = false;

                if (txtLogin.Text == "" || txtContrasena.Text == "")
                    MessageBox.Show("Para acceder debe indicar un Login y una Contraseña.", "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                {
                    if (Negocio.FachadaNegocio.GestionUsuarios.ComprobarLogin(txtLogin.Text, txtContrasena.Text))
                    {
                        var usuario = Negocio.FachadaNegocio.GestionUsuarios.ObtenerUsuario(txtLogin.Text);
                        if (usuario != null)
                            Negocio.FachadaNegocio.SesionUsuario.Instanciar(usuario.IdUsuario.GetValueOrDefault(), usuario.Rol, usuario.IdDepartamento);
                        
                        LoginCorrecto = true;
                        this.Close();
                    }
                    else
                        MessageBox.Show("Las credenciales de acceso no son válidas.", "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Atención", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            
        }

        private void btnSalir_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnAyuda_Click(object sender, EventArgs e)
        {
            var ayuda = new StringBuilder();
            ayuda.Append("Para acceder al sistema debe introducir su login y contraseña. \n"); 
            ayuda.Append("En caso de no conocer estos datos debe ponerse en contacto con su responsable de departamento o con el administrador del sistema.");
            MessageBox.Show(ayuda.ToString(), "Ayuda", MessageBoxButtons.OK, MessageBoxIcon.Question);
        }


        private void txtContrasena_keyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                btnEntrar_Click(sender, null);
        }
    }
}
