﻿using Negocio.Modulos;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Negocio.FachadaNegocio
{
    public class GesitonTiposGasto
    {
        private static Datos.AccesoDatos.TiposGasto _miAccesoDatos;
        private static Datos.AccesoDatos.TiposGasto MiAccesoDatos
        {
            get 
            {
                if (_miAccesoDatos == null)
                    _miAccesoDatos = Datos.AccesoDatos.TiposGasto.Instanciar();

                return _miAccesoDatos;
            }
        }

        public static ICollection<TipoGasto> ObtenerTiposGastos()
        {
            var tiposGastoPOCO = MiAccesoDatos.ObtenerTiposGasto();
            var tiposGasto = new Collection<TipoGasto>();

            foreach (var tipoGastoPOCO in tiposGastoPOCO)
            {
                tiposGasto.Add(new TipoGasto(tipoGastoPOCO.idTipoGasto, tipoGastoPOCO.nombre, tipoGastoPOCO.activo));
            }

            return tiposGasto;
        }

        public static ICollection<TipoGasto> ObtenerTiposGastosActivos()
        {
            var tiposGastoPOCO = MiAccesoDatos.ObtenerTiposGastoActivos();
            var tiposGasto = new Collection<TipoGasto>();

            foreach (var tipoGastoPOCO in tiposGastoPOCO)
            {
                tiposGasto.Add(new TipoGasto(tipoGastoPOCO.idTipoGasto, tipoGastoPOCO.nombre, tipoGastoPOCO.activo));
            }

            return tiposGasto;
        }

        public static TipoGasto ObtenerTipoGasto(int idTipoGasto)
        {
            var tipoGastoPOCO = MiAccesoDatos.ObtenerTipoGasto(idTipoGasto);
            return new TipoGasto(tipoGastoPOCO.idTipoGasto, tipoGastoPOCO.nombre, tipoGastoPOCO.activo);
        }

        public static void CrearTipoGasto(TipoGasto tipoGasto)
        {
            if (!MiAccesoDatos.ExisteTiposGasto(tipoGasto.Nombre))
                MiAccesoDatos.CrearTipoGasto(tipoGasto.Nombre, tipoGasto.Activo);
            else
                throw new Exception("El tipo de gasto " + tipoGasto.Nombre + " ya existe.");
            }

        public static void ModificarTipoGasto(TipoGasto tipoGasto)
        {
            MiAccesoDatos.ModificarTipoGasto(tipoGasto.IdTipoGasto.GetValueOrDefault(), tipoGasto.Nombre, tipoGasto.Activo);
        }

        public static bool TipoGastoRepetido(int idTipoGasto, String nombre)
        {
            var tipoGastoPOCO = MiAccesoDatos.ObtenerTipoGasto(nombre);
            if (tipoGastoPOCO == null)
                return false;
            else if (tipoGastoPOCO.idTipoGasto == idTipoGasto)
                return false;
            else
                return true;
        }
    }
}
