﻿using Negocio.Modulos;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Negocio.FachadaNegocio
{
    public class GestionDepartamentos
    {
        private static Datos.AccesoDatos.Departamentos _miAccesoDatos;
        private static Datos.AccesoDatos.Departamentos MiAccesoDatos
        {
            get 
            {
                if (_miAccesoDatos == null)
                    _miAccesoDatos = Datos.AccesoDatos.Departamentos.Instanciar();

                return _miAccesoDatos;
            }
        }
       
        public static ICollection<Departamento> ObtenerDepartamentos()
        {
            var departamentosPOCO = MiAccesoDatos.ObtenerDepartamentos();
            var departamentos = new Collection<Departamento>();

            foreach (var departamentoPOCO in departamentosPOCO)
            {
                departamentos.Add(new Departamento(departamentoPOCO.idDepartamento, departamentoPOCO.nombre, departamentoPOCO.activo, departamentoPOCO.porcentajePlusFestivo));
            }

            return departamentos;
        }

        public static Departamento ObtenerDepartamento(int idDepartamento)
        {
            var departamentoPOCO = MiAccesoDatos.ObtenerDepartamento(idDepartamento);
            return new Departamento(departamentoPOCO.idDepartamento, departamentoPOCO.nombre, departamentoPOCO.activo, departamentoPOCO.porcentajePlusFestivo);
        }

        public static void CrearDepartamento(Departamento departamento)
        {
            var departamentoPOCO = MiAccesoDatos.ObtenerDepartamento(departamento.Nombre);
            if (departamentoPOCO != null)
                throw new Exception("El departamento '" + departamento.Nombre + "' ya existe.");
    
            MiAccesoDatos.CrearDepartamento(departamento.Nombre, departamento.Activo, departamento.PorcentajePlusFestivo);
        }

        public static void ModificarDepartamento(Departamento departamento)
        {
            MiAccesoDatos.ModificarDepartamento(departamento.IdDepartamento.GetValueOrDefault(), departamento.Nombre, departamento.Activo, departamento.PorcentajePlusFestivo);
        }

        public static bool DepartamentoRepetido(int idDepartamento, String nombre)
        {
            var departamentoPOCO = MiAccesoDatos.ObtenerDepartamento(nombre);
            if (departamentoPOCO == null)
                return false;
            else if (departamentoPOCO.idDepartamento == idDepartamento)
                return false;
            else
                return true;
        }
    }
}
