﻿using Negocio.Modulos;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Negocio.FachadaNegocio
{
    public class GestionFestivos
    {
        private static Datos.AccesoDatos.Festivos _miAccesoDatos;
        private static Datos.AccesoDatos.Festivos MiAccesoDatos
        {
            get 
            {
                if (_miAccesoDatos == null)
                    _miAccesoDatos = Datos.AccesoDatos.Festivos.Instanciar();

                return _miAccesoDatos;
            }
        }

        public static ICollection<Festivo> ObtenerFestivos()
        {
            var festivosPOCO = MiAccesoDatos.ObtenerFestivos();
            var festivos = new Collection<Festivo>();

            foreach (var festivoPOCO in festivosPOCO)
            {
                festivos.Add(new Festivo(festivoPOCO.fecha, festivoPOCO.descripcion));
            }

            return festivos;
        }

        public static Festivo ObtenerFestivo(DateTime fecha)
        {
            var festivoPOCO = MiAccesoDatos.ObtenerFestivo(fecha);
            if (festivoPOCO != null)
                return new Festivo(festivoPOCO.fecha, festivoPOCO.descripcion);
            else
                return null;
        }

        public static void CrearFestivo(Festivo festivo)
        {
            var festivoPOCO = MiAccesoDatos.ObtenerFestivo(festivo.Fecha);
            if (festivoPOCO == null)
                MiAccesoDatos.CrearFestivo(festivo.Fecha, festivo.Descripcion);
            else
                MiAccesoDatos.ModificarFestivo(festivo.Fecha, festivo.Descripcion);
        }

        public static void ModificarFestivo(Festivo festivo)
        {
            MiAccesoDatos.ModificarFestivo(festivo.Fecha, festivo.Descripcion);
        }

        public static void EliminarFestivo(Festivo festivo)
        {
            MiAccesoDatos.EliminarFestivo(festivo.Fecha);
        }

        public static void EliminarFestivo(DateTime fecha)
        {
            MiAccesoDatos.EliminarFestivo(fecha);
        }
    }
}
