﻿using Negocio.Modulos;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Negocio.FachadaNegocio
{
    public class SesionUsuario
    {
        private static SesionUsuario _sesionUsuario;

        public int IdUsuario { get; set; }
        public TipoRolUsuario Rol { get; set; }
        public int IdDepartamento { get; set; }

        private SesionUsuario(int idUsuario, TipoRolUsuario rol, int idDepartamento)
        {
            IdUsuario = idUsuario;
            Rol = rol;
            IdDepartamento = idDepartamento;
        }

        private SesionUsuario()
        {

        }

        public static SesionUsuario Instanciar(int idUsuario, TipoRolUsuario rol, int idDepartamento)
        {
            if (_sesionUsuario == null)
                _sesionUsuario = new SesionUsuario(idUsuario, rol, idDepartamento);
            else
            {
                _sesionUsuario.IdUsuario = idUsuario;
                _sesionUsuario.Rol = rol;
                _sesionUsuario.IdDepartamento = idDepartamento;
            }
            return _sesionUsuario;
        }

        public static SesionUsuario Instanciar()
        {
            if (_sesionUsuario == null)
                _sesionUsuario = new SesionUsuario();

            return _sesionUsuario;
        }
    }
}
